/*
   Class Name:

      CFrustum.

   Created by:

      Allen Sherrod (Programming Ace of www.UltimateGameProgramming.com).

   Description:

      This class will allow us to use frustum culling to determine if objects are visible or not.
*/


#ifndef CFRUSTUM_H
#define CFRUSTUM_H

#define MAX_SIDES       6

// Not used...
#define NOT_VISIABLE    0
#define VISIABLE        1
#define PART_VISIABLE   2

#include"CPlane.h"
#include<math.h>
#include<stdio.h>


class CFrustum
{
   public:
      void CalculateFrustum(float *md, float *proj);
      bool isPointVisiable(float x, float y, float z);
      bool isSphereVisiable(float x, float y, float z, float radius);
      bool isBoxVisiable(float x, float y, float z, float size);
      bool isAABBVisiable(float minX, float minY, float minZ,
                          float maxX, float maxY, float maxZ);

   protected:
      void NormalizeFrustum();

   protected:
      CPlane Frustum[MAX_SIDES];
};

#endif


// Copyright December 2004
// All Rights Reserved!
// Allen Sherrod
// ProgrammingAce@UltimateGameProgramming.com
// www.UltimateGameProgramming.com