/*
   Class Name:

      CPlane.

   Created by:

      Allen Sherrod (Programming Ace of www.UltimateGameProgramming.com).

   Description:

      This class represents a plane in space.
*/


#ifndef CPLANE_H
#define CPLANE_H

// Simple defines to represent the state of something tested on the plane.
#define ON_PLANE     1
#define FRONT_PLANE  2
#define BEHIND_PLANE 3

#include"CVector.h"


class CPlane
{
   public:
      CPlane();
      CPlane(float A, float B, float C, float D);
      CPlane(CVector4 n, float D);
      CPlane(const CPlane &p);

      void CreatePlaneFromTri(CVector4 tri1, CVector4 tri2, CVector4 tri3);
      void SetPlaneNormal(float A, float B, float C);
      void SetPlaneIntercept(float D);

      bool Intersect(CPlane p2, CPlane p3, CVector4 &intersectPoint);
      int ClassifyPoint(CVector4 &v);
      int ClassifyPoint(float x, float y, float z);
      void Lerp(CPlane p1, CPlane p2, float amount);
      float GetDistance(CVector4 &v);
      float GetDistance(float x, float y, float z);

      float a;
      float b;
      float c;
      float d;
};


#endif


// Copyright January 2004
// All Rights Reserved!
// Allen Sherrod
// ProgrammingAce@UltimateGameProgramming.com
// www.UltimateGameProgramming.com